﻿using System;
using System.Collections.Generic;
using System.Text;
using METAbolt;
using METAxCommon;
using OpenMetaverse;
using SLNetworkComm;
using System.IO;

namespace Sample
{
    public class Extension : IExtension
    {
        // This is a sample class which transfers everything it gets via IM into public chat

        // Drop this uncompiled class into the Extensions folder of METAbolt

        // Change the below details to your own
        IHost host = null;
        string title = "Sample Extension";
        string description = "This is a sample extension (uncompiled class that shows how to develop extensions for METAbolt.";
        string author = "Legolas Luke";
        string version = "V1.0";


        #region IExtension Members
        public IHost Host
        {
            get { return host; }
            set { host = value; }
        }

        public string Title
        {
            get { return title; }
            set { title = value; }
        }

        public string Description
        {
            get { return description; }
            set { description = value; }
        }

        public string Author
        {
            get { return author; }
            set { author = value; }
        }

        public string Version
        {
            get { return version; }
            set { version = value; }
        }

        public void Process(METAboltInstance instance)
        {
            // Show the form to get user input or whatever
            // If you are not using forms then do whatever below
            // or call a process or class etc

            Sample_Extension ext = new Sample_Extension(instance);
            ext.StartExtension();
        }

        #endregion
    }

    public class Sample_Extension
    {
        Extension ext = new Extension();
        private METAboltInstance instance;
        private SLNetCom netcom;
        private GridClient client;

        public Sample_Extension(METAboltInstance instance)
        {
            this.instance = instance;
            netcom = this.instance.Netcom;
            client = this.instance.Client;

            // Say Hello to METAbolt
            if (ext.Host != null)
                ext.Host.HostStatus("Hello from sample extension");

        }

        // don't change this
        public void StartExtension()
        {
	        LoadEvents();
        }

        // Add the events you need in here
        private void LoadEvents()
        {
            netcom.InstantMessageReceived += new EventHandler<InstantMessageEventArgs>(netcom_InstantMessageReceived);
            netcom.ChatReceived += new EventHandler<ChatEventArgs>(netcom_ChatReceived);
        }

        private void netcom_InstantMessageReceived(object sender, InstantMessageEventArgs e)
        {
            if (e.IM.Dialog == InstantMessageDialog.StartTyping ||
                e.IM.Dialog == InstantMessageDialog.StopTyping)
                return;

            client.Self.Chat("[" + e.IM.FromAgentName + "] " +  e.IM.Message, 0, ChatType.Normal);
        }

        private void netcom_ChatReceived(object sender, ChatEventArgs e)
        {
            ProcessIncomingChat(e);
        }

        private void ProcessIncomingChat(ChatEventArgs e)
        {
            if (string.IsNullOrEmpty(e.Message)) return;  // ignore if message is empty

            if (e.Message.Substring(0, 1) == "@") return;   // Ignore RLV commands

            if (e.SourceType == ChatSourceType.Agent) return;  // ignore chat from avatars

            switch (e.Type)
            {
                case ChatType.OwnerSay:  // Relay all llOwnerSay type chat into public chat
                    client.Self.Chat("[" + e.FromName + "] " + e.Message, 0, ChatType.Normal);

                    break;
            }
        }
    }
}
